org.apache.hc.core5.http.io.entity

## Class HttpEntityWrapper

- java.lang.Object
- - org.apache.hc.core5.http.io.entity.HttpEntityWrapper

- All Implemented Interfaces:
    Closeable, AutoCloseable, EntityDetails, HttpEntity
  Direct Known Subclasses:
    BufferedHttpEntity

      @Contract(threading=IMMUTABLE_CONDITIONAL)
      public class HttpEntityWrapper
      extends Object
      implements HttpEntity

  Base class for wrapping entities that delegates all calls to the wrapped entity. Implementations can derive from this class and override only those methods that should not be delegated to the wrapped entity.
  Since:
    4.0

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `HttpEntityWrapper(HttpEntity wrappedEntity)` Creates a new entity wrapper.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `close()`
    `InputStream` | `getContent()` Gets a content stream of the entity.
    `String` | `getContentEncoding()` Gets content encoding of this entity, if known.
    `long` | `getContentLength()` Gets length of this entity, if known.
    `String` | `getContentType()` Gets content type of this entity, if known.
    `Set<String>` | `getTrailerNames()` Gets the preliminary declaration of trailing headers.
    `Supplier<List<? extends Header>>` | `getTrailers()` Gets supplier of message trailers - headers sent after message body.
    `boolean` | `isChunked()` Tests the chunked transfer hint for this entity.
    `boolean` | `isRepeatable()` Tests if the entity is capable of producing its data more than once.
    `boolean` | `isStreaming()` Tests whether this entity depends on an underlying stream.
    `String` | `toString()`
    `void` | `writeTo(OutputStream outStream)` Writes the entity content out to the output stream.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### HttpEntityWrapper

          public HttpEntityWrapper(HttpEntity wrappedEntity)

      Creates a new entity wrapper.
      Parameters:
        `wrappedEntity` - the entity to wrap.

  - ### Method Detail

    - #### isRepeatable

          public boolean isRepeatable()

      Description copied from interface: `HttpEntity`
      Tests if the entity is capable of producing its data more than once. A repeatable entity's getContent() and writeTo(OutputStream) methods can be called more than once whereas a non-repeatable entity's can not.
      Specified by:
        `isRepeatable` in interface `HttpEntity`
      Returns:
        true if the entity is repeatable, false otherwise.

    - #### isChunked

          public boolean isChunked()

      Description copied from interface: `EntityDetails`
      Tests the chunked transfer hint for this entity.

      The behavior of wrapping entities is implementation dependent, but should respect the primary purpose.

      Specified by:
        `isChunked` in interface `EntityDetails`
      Returns:
        the chunked transfer hint for this entity.

    - #### getContentLength

          public long getContentLength()

      Description copied from interface: `EntityDetails`
      Gets length of this entity, if known.
      Specified by:
        `getContentLength` in interface `EntityDetails`
      Returns:
        the length of this entity, may be `0`.

    - #### getContentType

          public String getContentType()

      Description copied from interface: `EntityDetails`
      Gets content type of this entity, if known.
      Specified by:
        `getContentType` in interface `EntityDetails`
      Returns:
        the content type of this entity, may be `null`.

    - #### getContentEncoding

          public String getContentEncoding()

      Description copied from interface: `EntityDetails`
      Gets content encoding of this entity, if known.
      Specified by:
        `getContentEncoding` in interface `EntityDetails`
      Returns:
        the content encoding of this entity, may be `null`.

    - #### getContent

          public InputStream getContent()
                                 throws IOException

      Description copied from interface: `HttpEntity`
      Gets a content stream of the entity. `Repeatable` entities are expected to create a new instance of `InputStream` for each invocation of this method and therefore can be consumed multiple times. Entities that are not `repeatable` are expected to return the same `InputStream` instance and therefore may not be consumed more than once.

      If this entity belongs to an incoming HTTP message, calling `InputStream.close()` on the returned `InputStream` will try to consume the complete entity content to keep the connection alive. In cases where this is undesired, e.g. when only a small part of the content is relevant and consuming the complete entity content would be too inefficient, only the HTTP message from which this entity was obtained should be closed (if supported).

      IMPORTANT: Please note all entity implementations must ensure that all allocated resources are properly deallocated after the `InputStream.close()` method is invoked.

      Specified by:
        `getContent` in interface `HttpEntity`
      Returns:
        content stream of the entity.
      Throws:
        `IOException` - if the stream could not be created
      See Also:
        `HttpEntity.isRepeatable()`

    - #### writeTo

          public void writeTo(OutputStream outStream)
                       throws IOException

      Description copied from interface: `HttpEntity`
      Writes the entity content out to the output stream.

      IMPORTANT: Please note all entity implementations must ensure that all allocated resources are properly deallocated when this method returns.

      Specified by:
        `writeTo` in interface `HttpEntity`
      Parameters:
        `outStream` - the output stream to write entity content to
      Throws:
        `IOException` - if an I/O error occurs

    - #### isStreaming

          public boolean isStreaming()

      Description copied from interface: `HttpEntity`
      Tests whether this entity depends on an underlying stream. Streamed entities that read data directly from the socket should return `true`. Self-contained entities should return `false`. Wrapping entities should delegate this call to the wrapped entity.
      Specified by:
        `isStreaming` in interface `HttpEntity`
      Returns:
        `true` if the entity content is streamed, `false` otherwise

    - #### getTrailers

          public Supplier<List<? extends Header>> getTrailers()

      Description copied from interface: `HttpEntity`
      Gets supplier of message trailers - headers sent after message body. May return `null` if trailers are not available.
      Specified by:
        `getTrailers` in interface `HttpEntity`

    - #### getTrailerNames

          public Set<String> getTrailerNames()

      Description copied from interface: `EntityDetails`
      Gets the preliminary declaration of trailing headers.
      Specified by:
        `getTrailerNames` in interface `EntityDetails`
      Returns:
        the preliminary declaration of trailing headers.

    - #### close

          public void close()
                     throws IOException

      Specified by:
        `close` in interface `Closeable`
      Specified by:
        `close` in interface `AutoCloseable`
      Throws:
        `IOException`

    - #### toString

          public String toString()

      Overrides:
        `toString` in class `Object`

Copyright © 2005–2021 The Apache Software Foundation. All rights reserved.